<?php

	// Dismiss Session
	PHPVC_SESSION::VAR_STOP();
	
	// Perform Login
    $SHORTCODE_STATUS = PHPCUS_SHORTCODE::CUS_QUICK_LOGIN();
	
	// Check Array Input
	PHPCUS_PARAM::CUS_DOES_NOT_SUPPORT_ARRAY();
	
	// Check already authenticated
	PHPCUS_PARAM::CUS_REQUIRES_AUTHENTICATION();
	// Check access rights. This may slow down server, uncomment this if you requires an extra security
	// PHPCUS_PARAM::CUS_HAS_PERMISSION(PHPCUS_SYSTEM::AUTHORITY_VIEW_ONLY, 'record_po_order');
	
	if
	(
		PHPRC_HTTP_PARAM::REF_ISSET_IN_ARRAY
		(
			[
					'PARAM_REC_PORDER_ID',
					'PARAM_REC_PORDER_CAT_COMPANY_ID',
					'PARAM_REC_PORDER_CODE',
					'PARAM_REC_PORDER_INVOICE_CODE',
					'PARAM_REC_PORDER_AMOUNT_FROM',
					'PARAM_REC_PORDER_AMOUNT_TO',
					'PARAM_REC_PORDER_REMARKS',
					'PARAM_REC_PORDER_DATE_EXPECT_FROM',
					'PARAM_REC_PORDER_DATE_EXPECT_TO',
					'PARAM_REC_PORDER_DATE_DELIVERY_FROM',
					'PARAM_REC_PORDER_DATE_DELIVERY_TO',
					'PARAM_REC_PORDER_ACC_ACCOUNT_ID',
					'PARAM_REC_PORDER_DATE_REQUEST_FROM',
					'PARAM_REC_PORDER_DATE_REQUEST_TO',
					'PARAM_REC_PORDER_STATUS',
					
					'PARAM_ORDER_FIELD',
					'PARAM_ORDER_TYPE',
					'PARAM_SKIP',
					'PARAM_LIMIT'
			], True
		)
	)
	{
		Try
		{
			// Read params
			// ------------------------------------------------------------------	
			$PARAM_REC_PORDER_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_PORDER_ID');
			$PARAM_REC_PORDER_CAT_COMPANY_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_PORDER_CAT_COMPANY_ID');
			$PARAM_REC_PORDER_CODE = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REC_PORDER_CODE');
			$PARAM_REC_PORDER_INVOICE_CODE = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REC_PORDER_INVOICE_CODE');
			$PARAM_REC_PORDER_AMOUNT_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_PORDER_AMOUNT_FROM');
			$PARAM_REC_PORDER_AMOUNT_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_PORDER_AMOUNT_TO');
			$PARAM_REC_PORDER_REMARKS = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REC_PORDER_REMARKS');
			$PARAM_REC_PORDER_DATE_EXPECT_FROM = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_REC_PORDER_DATE_EXPECT_FROM');
			$PARAM_REC_PORDER_DATE_EXPECT_TO = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_REC_PORDER_DATE_EXPECT_TO');
			$PARAM_REC_PORDER_DATE_DELIVERY_FROM = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_REC_PORDER_DATE_DELIVERY_FROM');
			$PARAM_REC_PORDER_DATE_DELIVERY_TO = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_REC_PORDER_DATE_DELIVERY_TO');
			$PARAM_REC_PORDER_ACC_ACCOUNT_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_PORDER_ACC_ACCOUNT_ID');
			$PARAM_REC_PORDER_DATE_REQUEST_FROM = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_REC_PORDER_DATE_REQUEST_FROM');
			$PARAM_REC_PORDER_DATE_REQUEST_TO = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_REC_PORDER_DATE_REQUEST_TO');
			$PARAM_REC_PORDER_STATUS = PHPCUS_PARAM::CUS_READ_INT('PARAM_REC_PORDER_STATUS');
			
			$PARAM_ORDER_FIELD = PHPCUS_PARAM::CUS_READ_SORT_FIELD
			(
					'PARAM_ORDER_FIELD',
					[
						'REC_PORDER_ID', 
						'REC_PORDER_CAT_COMPANY_ID', 
						'REC_PORDER_CODE', 
						'REC_PORDER_INVOICE_CODE', 
						'REC_PORDER_AMOUNT', 
						'REC_PORDER_REMARKS', 
						'REC_PORDER_DATE_EXPECT', 
						'REC_PORDER_DATE_DELIVERY', 
						'REC_PORDER_ACC_ACCOUNT_ID', 
						'REC_PORDER_DATE_REQUEST', 
						'REC_PORDER_STATUS'
						, 
						'CAT_COMPANY_ID',		
						'CAT_COMPANY_DESCRIPTION',		
						'CAT_COMPANY_TIN',		
						'CAT_COMPANY_ADDRESS',		
						'CAT_COMPANY_MOBILE',		
						'CAT_COMPANY_PHONE',		
						'CAT_COMPANY_FAX',		
						'CAT_COMPANY_EMAIL',		
						'CAT_COMPANY_WEBSITE',		
						'CAT_COMPANY_SNS_PAGE',		
						'CAT_COMPANY_COMPANY_TYPE',		
						'CAT_COMPANY_REMARKS',		
						'CAT_COMPANY_STATUS',		
						'CAT_COMPANY_SYSTEM_GENERATED',		
						'ACC_ACCOUNT_ID',		
						'ACC_ACCOUNT_SERVER_ID',		
						'ACC_ACCOUNT_ACC_LEVEL_ID',		
						'ACC_ACCOUNT_ACC_GROUP_ID',		
						'ACC_ACCOUNT_ADD_RESOURCE_ID',		
						'ACC_ACCOUNT_USERNAME',		
						'ACC_ACCOUNT_PASSWORD',		
						'ACC_ACCOUNT_AUTH_CODE',		
						'ACC_ACCOUNT_FIRST_NAME',		
						'ACC_ACCOUNT_MIDDLE_NAME',		
						'ACC_ACCOUNT_LAST_NAME',		
						'ACC_ACCOUNT_POSITION',		
						'ACC_ACCOUNT_SYS_GENDER_ID',		
						'ACC_ACCOUNT_STATUS',		
						'ACC_ACCOUNT_SYSTEM_GENERATED'		
					]
			);		
			$PARAM_ORDER_TYPE = PHPCUS_PARAM::CUS_READ_SORT_TYPE('PARAM_ORDER_TYPE');
			$PARAM_SKIP	= PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_SKIP');
			$PARAM_LIMIT = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_LIMIT');
			
			// ------------------------------------------------------------------
			
			
			// Populate Map Array
			// ...........................................
			$GET_MAP_ARRAY = PHPCUS_RECORD_PO_ORDER::CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
			
			$GET_MAP_ARRAY['PARAM_REC_PORDER_ID'] = $PARAM_REC_PORDER_ID;
			$GET_MAP_ARRAY['PARAM_REC_PORDER_CAT_COMPANY_ID'] = $PARAM_REC_PORDER_CAT_COMPANY_ID;
			$GET_MAP_ARRAY['PARAM_REC_PORDER_CODE'] = $PARAM_REC_PORDER_CODE;
			$GET_MAP_ARRAY['PARAM_REC_PORDER_INVOICE_CODE'] = $PARAM_REC_PORDER_INVOICE_CODE;
			$GET_MAP_ARRAY['PARAM_REC_PORDER_AMOUNT_FROM'] = $PARAM_REC_PORDER_AMOUNT_FROM;
			$GET_MAP_ARRAY['PARAM_REC_PORDER_AMOUNT_TO'] = $PARAM_REC_PORDER_AMOUNT_TO;
			$GET_MAP_ARRAY['PARAM_REC_PORDER_REMARKS'] = $PARAM_REC_PORDER_REMARKS;
			$GET_MAP_ARRAY['PARAM_REC_PORDER_DATE_EXPECT_FROM'] = $PARAM_REC_PORDER_DATE_EXPECT_FROM;
			$GET_MAP_ARRAY['PARAM_REC_PORDER_DATE_EXPECT_TO'] = $PARAM_REC_PORDER_DATE_EXPECT_TO;
			$GET_MAP_ARRAY['PARAM_REC_PORDER_DATE_DELIVERY_FROM'] = $PARAM_REC_PORDER_DATE_DELIVERY_FROM;
			$GET_MAP_ARRAY['PARAM_REC_PORDER_DATE_DELIVERY_TO'] = $PARAM_REC_PORDER_DATE_DELIVERY_TO;
			$GET_MAP_ARRAY['PARAM_REC_PORDER_ACC_ACCOUNT_ID'] = $PARAM_REC_PORDER_ACC_ACCOUNT_ID;
			$GET_MAP_ARRAY['PARAM_REC_PORDER_DATE_REQUEST_FROM'] = $PARAM_REC_PORDER_DATE_REQUEST_FROM;
			$GET_MAP_ARRAY['PARAM_REC_PORDER_DATE_REQUEST_TO'] = $PARAM_REC_PORDER_DATE_REQUEST_TO;
			$GET_MAP_ARRAY['PARAM_REC_PORDER_STATUS'] = $PARAM_REC_PORDER_STATUS;
			
			$GET_MAP_ARRAY["PARAM_ORDER_FIELD"] = $PARAM_ORDER_FIELD;
			$GET_MAP_ARRAY["PARAM_ORDER_TYPE"] = $PARAM_ORDER_TYPE;
			$GET_MAP_ARRAY["PARAM_SKIP"] = $PARAM_SKIP;
			$GET_MAP_ARRAY["PARAM_LIMIT"] = $PARAM_LIMIT;
			
			
			// Execute Stored Procedure
			// ...........................................
			$DATA_SET = PHPCUS_RECORD_PO_ORDER::CUS_GET_MA($GET_MAP_ARRAY);
			
						
			// Return JSON response
			// ...........................................
			if(empty($DATA_SET) === False)
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS($DATA_SET);
			}
			else
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS('');
			}
			
		}
		Catch(Exception $ERR)
		{		
			PHPVC_LOG::VAR_REPORT_ERROR($ERR, 0);
			if(isset($_SERVER['HTTP_ORIGIN']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_ORIGIN', $_SERVER['HTTP_ORIGIN']);
			}
			if(isset($_SERVER['HTTP_HOST']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_HOST', $_SERVER['HTTP_HOST']);
			}		
			if(isset($_SERVER['HTTP_REFERER']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_REFERER', $_SERVER['HTTP_REFERER']);
			}
			if(isset($_SERVER['REMOTE_ADDR']))
			{
			    PHPVC_LOG::VAR_ERROR('REMOTE_ADDR', $_SERVER['REMOTE_ADDR']);
			}
			
			PHPCUS_PARAM::CUS_JSON_ERROR($ERR->getMessage());
		}
	}
	else
	{
		PHPCUS_PARAM::CUS_JSON_ERROR('Missing parameters');
	}

?>